using FluentValidation;

namespace MvcFV.Models
{
    public class AlunoValidator : AbstractValidator<Aluno>
    {
           public AlunoValidator()
           {
                //Definição das validações 
                RuleFor(x => x.Nome)
                    .NotEmpty().WithMessage("Informe o nome do Aluno")
                    .Length(3, 100).WithMessage("O nome deve ter no mínimo 3 caracteres e no máximo 100 caracteres");

                RuleFor(c => c.Email)
                    .NotEmpty().WithMessage("Informe o e-mail do Aluno")
                    .EmailAddress().WithMessage("E-mail inválido");
        
                RuleFor(c => c.DataNascimento)
                    .NotEmpty().WithMessage("Informe a data de nascimento do Aluno")
                    .Must(AlunoMaiorDeIdade).WithMessage("O aluno deve ser maior que 18 anos");
           }
            private static bool AlunoMaiorDeIdade(System.DateTime dataNascimento)
            {
               return dataNascimento <= System.DateTime.Now.AddYears(-18);
            }
     }
}